/**
 * 
 */
package cz.muni.fi.pb162.radio;

import cz.muni.fi.pb162.music.Song;
import cz.muni.fi.pb162.radio.parts.CDPlayer;
import cz.muni.fi.pb162.radio.parts.Displayable;
import cz.muni.fi.pb162.radio.parts.GivingSound;
import cz.muni.fi.pb162.radio.parts.Switchable;

/**
 * @author xpecho
 * 
 */
public class CarRadio extends UniversalRadio implements CDPlayer {

	private Song[] cd;

	private int actualSongIndex = -1;

	/**
	 * @param radioSwitch
	 * @param speaker
	 * @param display
	 */
	public CarRadio(Switchable radioSwitch, GivingSound speaker,
			Displayable display) {
		super(radioSwitch, speaker, display);
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#ejectCD()
	 */
	@Override
	public Song[] ejectCD() {
		Song[] temp = cd;
		this.cd = null;
		return temp;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#next()
	 */
	@Override
	public void next() {
		if(actualSongIndex < cd.length -1){
			actualSongIndex++;
		}else {
			actualSongIndex = 0;
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#play()
	 */
	@Override
	public void play() {
		actualSongIndex = 0;

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#previous()
	 */
	@Override
	public void previous() {
		if (actualSongIndex > 0) {
			actualSongIndex--;
		}else {
			actualSongIndex = cd.length -1;
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * cz.muni.fi.pb162.radio.parts.CDPlayer#putCD(cz.muni.fi.pb162.music.Song
	 * [])
	 */
	@Override
	public void putCD(Song[] cd) {
		this.cd = cd;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see cz.muni.fi.pb162.radio.parts.CDPlayer#stop()
	 */
	@Override
	public void stop() {
		actualSongIndex = -1;
	}

	@Override
	public Song actualSong() {
		return actualSongIndex > -1? cd[actualSongIndex]: null;
	}

	/* (non-Javadoc)
	 * @see cz.muni.fi.pb162.radio.UniversalRadio#increaseVolume()
	 */
	@Override
	public void increaseVolume() {
		// TODO Auto-generated method stub
		GivingSound speaker = getSpeaker();
		speaker.setVolume(speaker.getVolume() + 2);
	}
	
	

}
